config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :scores

  resources :works

  resources :work_records

  root 'users#show'

end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
  has_many :works
  has_many :work_records, through: :works
  has_one :score

  def checked_works(date = nil)
    date = Time.now unless date
    works.select { |w| w.checked?(date) }
  end

  def unchecked_works(date = nil)
    date = Time.now unless date
    works.select { |w| not w.checked?(date) }
  end

end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:show, :edit, :update, :destroy]

  # GET /users
  # GET /users.json
  def index
    @users = User.all
  end

  # GET /users/1
  # GET /users/1.json
  def show
    @current_time = Time.now
    @work_record = WorkRecord.new
    session[:user_id] = @user.id
  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(user_params)

    respond_to do |format|
      if @user.save
        format.html { redirect_to @user, notice: 'User was successfully created.' }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to @user, notice: 'User was successfully updated.' }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to users_url, notice: 'User was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_user
      #@user = User.find(params[:id])
      @user = current_user
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def user_params
      params.require(:user).permit(:name)
    end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/users/_check_form.html.erb
<% if @user.unchecked_works.empty? %>
  <p>您已完成今天所有的任务!您真棒！</p>
<% else %>
    <% @rec = WorkRecord.new %>
    <%= form_for @rec, remote: true do |f|%>
        <%= f.label :work_id, value: 'Work'%>:
        <%= collection_select :work_record, :work_id, @user.unchecked_works, :id, :name%><br />

        <%= f.label :comment %>:
        <%= f.text_area :comment %><br />

        <%= f.submit value: 'Check' %><br />
    <% end %>
<% end %>

app/views/users/_checked_works.html.erb
<% unless @user.checked_works.empty? %>
<p>今天已经完成的任务：</p>
<table>
<% @user.checked_works.each do |work| %>
  <tr>
    <td><%=work.name%></td>
    <td><%=work.work_records.when(Time.now).first.created_at.strftime('%Y-%m-%d %H:%M:%S') %></td>
  </tr>
<% end %>
</table>
<% end %>

app/views/users/_form.html.erb
<%= form_for(@user) do |f| %>
  <% if @user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% @user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/users/edit.html.erb
<h1>Editing User</h1>

<%= render 'form' %>

<%= link_to 'Show', @user %> |
<%= link_to 'Back', users_path %>

app/views/users/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Users</h1>
<%	 @users.each do |user| %>
    <h3>Name: <%= user.name %></h3>
    <table>
      <thead>
      <tr>
        <th>Work</th>
        <th>Records</th>
      </tr>
      </thead>

      <tbody>
      <% user.works.each do |work| %>

            <% work.work_records.each do |rec|%>
              <tr>
                <td><%= work.name %></td>
                <td><%= rec.created_at %></td>
              </tr>
            <% end %>
      <% end %>
      </tbody>
    </table>

<% end %>
<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Passwords</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @users.each do |user| %>
      <tr>
        <td><%= user.name %></td>
        <td><%= user.password %></td>
        <td><%= link_to 'Show', user %></td>
        <td><%= link_to 'Edit', edit_user_path(user) %></td>
        <td><%= link_to 'Destroy', user, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

app/views/users/new.html.erb
<h1>New User</h1>

<%= render 'form' %>

<%= link_to 'Back', users_path %>

app/views/users/show.html.erb
<p id="notice"><%= notice %></p>

<h3><%=	 @user.name %></h3>
<p>今天是: <%= @current_time.strftime('%Y-%m-%d') %></p>
<div id="check_form">
  <%= render 'check_form' %>
</div>
<div id="checked_works">
  <%= render 'checked_works'%>
</div>

<%= link_to 'My Works', works_path %>
<%= link_to 'Show All Records', work_records_path(user_id:@user) %>